#!/usr/bin/env python
# -*- coding: utf-8 -*-
#http://nathanw.net/2012/03/30/custom-qgis-feature-forms-value-binding/
#http://nathanw.net/2013/08/02/death-to-the-messagebox-using-the-qgis-messagebar/
## Import the PyQt and QGIS libraries
from PyQt4.QtCore import *
from PyQt4.QtGui import *

'''docs'''
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import os
from platform import system

from qtibia_lib import *


#global variables to hold the dialog field
myDialog = None

def logic(dialog, layer, feature):
    print "intru logic"

    global myDialog
    myDialog = dialog

    global mylayerid
    mylayerid = layer

    global myfeatureid
    myfeatureid = feature.id()

    myDialog = meter_Class(dialog, layer, feature)


class meter_Class(QTibia_Dialog):
    def __init__(self, dialog, layer, feature):
        QTibia_Dialog.__init__(self, dialog, layer, feature)

        self.idField = dialog.findChild(QLineEdit, "id")
        self.idlabel = dialog.findChild(QLabel, "label")
        self.tab_principal = None #add to keep compatibility

        self.Combo_id_distributor   = dialog.findChild(QComboBox, "fk_distributor")
        self.Combo_id_status        = dialog.findChild(QComboBox, "fk_status")
        self.Combo_id_precision     = dialog.findChild(QComboBox, "fk_precision")
        self.Combo_id_precisionalti = dialog.findChild(QComboBox, "fk_precisionalti")

        self.need_fill= [self.Combo_id_distributor,
                         self.Combo_id_status]

        self.LineEdit_altitude      = dialog.findChild(QLineEdit, "altitude")
        self.LineEdit_altitude.editingFinished.connect(self.altitude_editingFinished)

        if(self.LineEdit_altitude.displayText() != ''):
            self.need_fill.append(self.Combo_id_precision    )
            self.need_fill.append(self.Combo_id_precisionalti)


        self.grid_Layout = dialog.findChild(QGridLayout, "gridLayout")
        if self.grid_Layout==None:
            QMessageBox.critical(dialog, "Eroare", "grid_Layout negasit", QMessageBox.Ok)
        self.ok_buttonBox = dialog.findChild(QDialogButtonBox, "buttonBox")
        if self.ok_buttonBox==None:
            QMessageBox.critical(dialog, "Eroare", "ok_buttonBox negasit", QMessageBox.Ok)

        m_lay= QHBoxLayout()
        #add widgets to layout
        m_lay.addWidget(self.btn_default_vals)
        m_lay.addWidget(self.ok_buttonBox)
        #add layout to grid
        self.grid_Layout.addLayout(m_lay, self.grid_Layout.rowCount()-1, self.grid_Layout.columnCount()-1)


        if len(self.idField.text()) > 0 and self.idField.text()[0] == 'n':    # daca id-ul e pe nextvalue
            self.idField.hide()
            #idlabel.hide()
            #idlabel.setText("<b>ID auto<b>")
            idField_replace =  QLineEdit()
            idField_replace.setText(u'Se completează automat la salvare')
            v_widget = self.idlabel.parentWidget()
            form_Layout = v_widget.layout()
            form_Layout.addWidget(idField_replace,0,1)
            idField_replace.setReadOnly(True)
            idField_replace.setEnabled(False)



        self.btn_default_vals.clicked["bool"].connect(self.defaultButtonClicked)

        mylayerid.editingStarted.connect(self.set_btn_visibility)
        mylayerid.editingStopped.connect(self.disconnect_after_stop_edit)

        if mylayerid.isEditable():
            self.btn_default_vals.show()
            self.set_if_is_new()
        else:
            self.btn_default_vals.hide()

    def defaultButtonClicked(self):
        if self.Combo_id_distributor.isVisible()  : self.setDefValues(self.Combo_id_distributor, 0)
        if self.Combo_id_status.isVisible()       : self.setDefValues(self.Combo_id_status     , u"Funcţional")
        self. f_verifica_daca_mai_am_combo_rosu()

    def altitude_editingFinished(self):
        if(self.LineEdit_altitude.displayText() != ''):
            if(self.Combo_id_precision not in self.need_fill ):
                self.need_fill.append(self.Combo_id_precision )
                self.need_fill.append(self.Combo_id_precisionalti)
                self.set_if_is_new()



