#!/usr/bin/env python
# -*- coding: utf-8 -*-
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import os
from platform import system

from qtibia_lib import *
#global variables to hold the dialog field
myDialog = None

def logic(dialog, layer, feature):
    print "intru logic"

    global myDialog
    myDialog = dialog

    global mylayerid
    mylayerid = layer

    global myfeatureid
    myfeatureid = feature.id()

    myDialog = Pipe_Class(dialog, layer, feature)


class Pipe_Class(QTibia_Dialog):
    def __init__(self, dialog, layer, feature):
        print "uau"
        QTibia_Dialog.__init__(self, dialog, layer, feature)

        self.distributorCombo = dialog.findChild(QComboBox, "fk_distributor")
        self.statusCombo      = dialog.findChild(QComboBox, "fk_status")
        self.functionCombo    = dialog.findChild(QComboBox, "fk_function")
        self.beddingCombo     = dialog.findChild(QComboBox, "fk_bedding")
        self.installmethodCombo = dialog.findChild(QComboBox, "fk_installmethod")
        self.watertypeCombo     = dialog.findChild(QComboBox, "fk_watertype")
        self.precisionCombo     = dialog.findChild(QComboBox, "fk_precision")
       




        self.tab_principal      = dialog.findChild(QTabWidget, "tabWidget")
        self.idField            = dialog.findChild(QLineEdit, "id")
        self.idlabel            = dialog.findChild(QLabel, "label_5")
        self.docsLabel          = dialog.findChild(QLabel, "labelDocs")


        self.gridLayout = dialog.findChild(QGridLayout, "gridLayout_3")
        self.ok_buttonBox = dialog.findChild(QDialogButtonBox, "buttonBox")

        m_lay= QHBoxLayout()
        #add widgets to layout
        m_lay.addWidget(self.btn_default_vals)
        m_lay.addWidget(self.ok_buttonBox)
        #add layout to grid
        self.gridLayout.addLayout(m_lay, self.gridLayout.rowCount()-1, self.gridLayout.columnCount()-1)

        #calls the function that sets the buttton visibility
        #variable holding the widgets that don't permit null values when passing the form
        self.need_fill= [self.distributorCombo,
                         self.statusCombo,
                         self.functionCombo,
                         self.beddingCombo,
                         self.installmethodCombo,
                         self.watertypeCombo,
                         self.precisionCombo]


        # global stop_icon
        # stop_icon = QIcon(os.path.join(os.path.dirname(__file__),"icon","stop.ico"))

        if system()=='Windows':
            global v_original_color
            v_original_color = self.tab_principal.tabBar().tabTextColor(0)

        if len(self.idField.text()) > 0 and self.idField.text()[0] == 'n':    # daca id-ul e pe nextvalue

            print "next value"
            self.idField.hide()
            #idlabel.hide()
            #idlabel.setText("<b>ID auto<b>")
            self.idField_replace =  QLineEdit()
            self.idField_replace.setText(u'Se completează automat la salvare')
            v_widget = self.idlabel.parentWidget()
            self.form_Layout = v_widget.layout()
            self.form_Layout.addWidget(self.idField_replace, 0, Qt.AlignLeft)
            self.idField_replace.setReadOnly(True)
            self.idField_replace.setEnabled(False)



           #setez buton ok sa fie rosu
            v_buton_ok = self.ok_buttonBox.button(QDialogButtonBox.Ok)
            v_buton_ok.setStyleSheet("background-color: rgba(255,0,0,50);")


        self.btn_default_vals.clicked["bool"].connect(self.defaultButtonClicked)
        mylayerid.editingStarted.connect(self.set_btn_visibility)
        mylayerid.editingStopped.connect(self.disconnect_after_stop_edit)

        if mylayerid.isEditable():
            self.btn_default_vals.show()
            self.set_if_is_new()
        else:
            self.btn_default_vals.hide()


    def defaultButtonClicked(self):
        if self.distributorCombo.isVisible()  : self.setDefValues(self.distributorCombo, 0)
        if self.statusCombo.isVisible()       : self.setDefValues(self.statusCombo, u"Funcţional")
        if self.functionCombo.isVisible()     : self.setDefValues(self.functionCombo,  5)
        if self.installmethodCombo.isVisible(): self.setDefValues(self.installmethodCombo, u"Excavare")
        if self.beddingCombo.isVisible()      : self.setDefValues(self.beddingCombo, u"nisip")
        if self.watertypeCombo.isVisible()    : self.setDefValues(self.watertypeCombo, u"potabilă")
        self.f_verifica_daca_mai_am_combo_rosu()
