#!/usr/bin/env python
# -*- coding: utf-8 -*-
#http://nathanw.net/2012/03/30/custom-qgis-feature-forms-value-binding/
#http://nathanw.net/2013/08/02/death-to-the-messagebox-using-the-qgis-messagebar/
## Import the PyQt and QGIS libraries
from PyQt4.QtCore import *
from PyQt4.QtGui import *

'''docs'''
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import os
from platform import system

from qtibia_lib import *


#global variables to hold the dialog field
myDialog = None

def logic(dialog, layer, feature):
    print "intru logic subscriber"

    global myDialog
    myDialog = dialog

    global mylayerid
    mylayerid = layer

    global myfeatureid
    myfeatureid = feature.id()

    myDialog = subscriber_Class(dialog, layer, feature)


class subscriber_Class(QTibia_Dialog):
    def __init__(self, dialog, layer, feature):
        QTibia_Dialog.__init__(self, dialog, layer, feature)

        self.tab_principal = None # add for compatibility

        self.Combo_fk_subscriber_type   = dialog.findChild(QComboBox, "fk_subscriber_type")
        self.Combo_fk_status            = dialog.findChild(QComboBox, "fk_status")
        self.Combo_fk_distributor     = dialog.findChild(QComboBox, "fk_distributor")

        self.need_fill= [self.Combo_fk_subscriber_type,
                         self.Combo_fk_status,
                         self.Combo_fk_distributor]

        self.grid_Layout = dialog.findChild(QGridLayout, "gridLayout")
        if self.grid_Layout==None:
            QMessageBox.critical(dialog, "Eroare", "grid_Layout negasit", QMessageBox.Ok)
        self.ok_buttonBox = dialog.findChild(QDialogButtonBox, "buttonBox")
        if self.ok_buttonBox==None:
            QMessageBox.critical(dialog, "Eroare", "ok_buttonBox negasit", QMessageBox.Ok)

        m_lay= QHBoxLayout()
        #add widgets to layout
        m_lay.addWidget(self.btn_default_vals)
        m_lay.addWidget(self.ok_buttonBox)
        #add layout to grid
        self.grid_Layout.addLayout(m_lay, self.grid_Layout.rowCount()-1, self.grid_Layout.columnCount()-1)



        self.btn_default_vals.clicked["bool"].connect(self.defaultButtonClicked)

        mylayerid.editingStarted.connect(self.set_btn_visibility)
        mylayerid.editingStopped.connect(self.disconnect_after_stop_edit)

        if mylayerid.isEditable():
            self.btn_default_vals.show()
            self.set_if_is_new()
        else:
            self.btn_default_vals.hide()

    def defaultButtonClicked(self):
        if self.Combo_fk_subscriber_type.isVisible() : self.setDefValues(self.Combo_fk_subscriber_type, 3)
        if self.Combo_fk_status.isVisible()          : self.setDefValues(self.Combo_fk_status         , 3)#u"Funcţional")
        if self.Combo_fk_distributor.isVisible()     : self.setDefValues(self.Combo_fk_distributor    , 0)#u"Funcţional")

        self.f_verifica_daca_mai_am_combo_rosu()

