#!/usr/bin/env python
# -*- coding: utf-8 -*-
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import os
from platform import system

from qtibia_lib import *

#!/us/bin/env python
# -*- coding: utf-8 -*-

#global variables to hold the dialog field
myDialog = None

def logic(dialog, layer, feature):
    print "intru logic"

    global myDialog
    myDialog = dialog

    global mylayerid
    mylayerid = layer

    global myfeatureid
    myfeatureid = feature.id()

    myDialog = valve_Class(dialog, layer, feature)


class valve_Class(QTibia_Dialog):
    def __init__(self, dialog, layer, feature):
        QTibia_Dialog.__init__(self, dialog, layer, feature)


        self.idField = dialog.findChild(QLineEdit, "id")
        self.idlabel = dialog.findChild(QLabel, "label")
        self.Combo_fk_type = dialog.findChild(QComboBox, "fk_valve_type")
        self.Combo_fk_function = dialog.findChild(QComboBox, "fk_valve_function")
        self.Combo_fk_valve_actuation = dialog.findChild(QComboBox, "fk_valve_actuation")
        self.Combo_fk_status = dialog.findChild(QComboBox, "fk_status")
        self.Combo_fk_precisionalti  = dialog.findChild(QComboBox, "fk_precisionalti")
        self.Combo_fk_precision = dialog.findChild(QComboBox, "fk_precision")
        self.Combo_fk_distributor = dialog.findChild(QComboBox, "fk_distributor")

        self.need_fill= [self.Combo_fk_type,
                    self.Combo_fk_function,
                    self.Combo_fk_valve_actuation,
                    self.Combo_fk_status,
                    self.Combo_fk_distributor]

        self.LineEdit_altitude      = dialog.findChild(QLineEdit, "altitude")
        self.LineEdit_altitude.editingFinished.connect(self.altitude_editingFinished)
        if(self.LineEdit_altitude.displayText() != ''):
            self.need_fill.append(self.Combo_fk_precision    )
            self.need_fill.append(self.Combo_fk_precisionalti)

        self.tab_principal = dialog.findChild(QTabWidget, "tabWidget")
        self.grid_Layout   = dialog.findChild(QGridLayout, "gridLayout")
        self.ok_buttonBox  = dialog.findChild(QDialogButtonBox, "buttonBox")
        m_lay= QHBoxLayout()
        #add widgets to layout
        m_lay.addWidget(self.btn_default_vals)
        m_lay.addWidget(self.ok_buttonBox)

        #add layout to grid
        self.grid_Layout.addLayout(m_lay,self. grid_Layout.rowCount()-1, self.grid_Layout.columnCount()-1)
        #variable holding the widgets that don't permit null values when passing the form
        if system()=='Windows':
             global v_original_color
             v_original_color = self.tab_principal.tabBar().tabTextColor(0)

        if len(self.idField.text()) > 0 and self.idField.text()[0] == 'n':    # daca id-ul e pe nextvalue
            self.idField.hide()
            #idlabel.hide()
            #idlabel.setText("<b>ID auto<b>")
            self.idField_replace =  QLineEdit()
            self.idField_replace.setText(u'Se completează automat la salvare')
            v_widget = self.idlabel.parentWidget()
            self.form_Layout = v_widget.layout()
            self.form_Layout.addWidget(self.idField_replace,0,1)
            self.idField_replace.setReadOnly(True)
            self.idField_replace.setEnabled(False)


        self.btn_default_vals.clicked["bool"].connect(self.defaultButtonClicked)

        mylayerid.editingStarted.connect(self.set_btn_visibility)
        mylayerid.editingStopped.connect(self.disconnect_after_stop_edit)

        if mylayerid.isEditable():
            self.btn_default_vals.show()
            self.set_if_is_new()
        else:
            self.btn_default_vals.hide()


    def defaultButtonClicked(self):
        if self.Combo_fk_distributor.isVisible(): self.setDefValues(self.Combo_fk_distributor        	, 0)
        if self.Combo_fk_type.isVisible()       : self.setDefValues(self.Combo_fk_type			, u"vană")
        if self.Combo_fk_valve_actuation.isVisible()  : self.setDefValues(self.Combo_fk_valve_actuation	, 3)  # set valve actuation value as manual
        if self.Combo_fk_status.isVisible()     : self.setDefValues(self.Combo_fk_status             	, u"Funcţional")
        self.f_verifica_daca_mai_am_combo_rosu()


    def altitude_editingFinished(self):
        if(self.LineEdit_altitude.displayText() != ''):
            if(self.Combo_fk_precision not in self.need_fill ):
                self.need_fill.append(self.Combo_fk_precision )
                self.need_fill.append(self.Combo_fk_precisionalti)
                self.set_if_is_new()

